(function($, Drupal) {
  var path = drupalSettings.server_sent_events.channel.channel_path;
  var pushPath = drupalSettings.server_sent_events.channel.push_path;
  var serverSideChannel = new ServerSideChannel(path,pushPath);
  serverSideChannel.eventSource.onmessage = function(message) {
    addLog('message',message.lastEventId,message.data);
  }
  serverSideChannel.eventSource.addEventListener("subscribe", function(message) {
    addLog('subscribe',message.lastEventId,message.data);
    refreshSubscribers();
  });
  serverSideChannel.eventSource.addEventListener("unsubscribe", function(message) {
    addLog('unsubscribe',message.lastEventId,message.data);
    refreshSubscribers();
  });

  function addLog(type,id,data){
    data = decodeURI(data);
    data.replace("\n",'<br>');
    $('#edit-live').append('<div><span>Event ID :'+id+'</span><br><span>Event type : '+type+'</span><br><span>Event message : '+data+'</span></div><hr>');
  }
  $(document).on('click' , '.test-push',function(){
    serverSideChannel.push(encodeURI($('#edit-test-push').val()));
  });

  function refreshSubscribers(){
    $subscribersPath = drupalSettings.server_sent_events.channel.subscribers_path;
    $.get($subscribersPath).done(function(data){
      console.log(data);

      $('#edit-subscribers-container').html(data.length);
    });
  }
})(jQuery, Drupal)
