<?php

namespace Drupal\server_sent_events;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;
use Drupal\Core\Link;

/**
 * Defines a class to build a listing of Channel subscription entities.
 *
 * @ingroup server_sent_events
 */
class ChannelSubscriptionListBuilder extends EntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['id'] = $this->t('Channel subscription ID');
    $header['name'] = $this->t('Name');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    /* @var \Drupal\server_sent_events\Entity\ChannelSubscription $entity */
    $row['id'] = $entity->id();
    $row['name'] = Link::createFromRoute(
      $entity->label(),
      'entity.channel_subscription.edit_form',
      ['channel_subscription' => $entity->id()]
    );
    return $row + parent::buildRow($entity);
  }

}
