<?php

namespace Drupal\server_sent_events\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\server_sent_events\Entity\ChannelSubscription;
use Drupal\server_sent_events\Entity\EventsChannel;
use Drupal\server_sent_events\Event\ServerSentEvent;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\StreamedResponse;
use Symfony\Component\HttpKernel\Exception\HttpException;

/**
 * Returns responses for Server Sent Events routes.
 */
class ServerSentEventsController extends ControllerBase {
  /**
   * Builds the response.
   */
  public function channel() {
    ignore_user_abort(1);
    $route = explode('.' ,\Drupal::routeMatch()->getRouteName());
    if($route[0] == 'server_sent_events' && $route[1] == 'channel'){
      $channelID = $route[2];
    }
    else{
      throw new HttpException("Invalid Channel");
    }
    $response = new StreamedResponse(function() use($channelID){
      $channelEntity = EventsChannel::load($channelID);
      $subscription = $channelEntity->subscribe();
      $x = 0;
      while (TRUE) {
        $events = $channelEntity->getPendingEvents($subscription);
        foreach ($events as $event) {
          $event->send();
        }
        //Replace 5 with configurable setting
        if($x % 5 == 0){
          $channelEntity->checkStatus($subscription);
        }
        $x++;
        sleep(1);
      }
    });
    $response->headers->set('Content-Type', 'text/event-stream');
    $response->send();
  }

  public function pushMessage(){
    $route = explode('.' ,\Drupal::routeMatch()->getRouteName());
    if($route[0] == 'server_sent_events' && $route[1] == 'channel' && $route[2] == 'push'){
      $channel = $route[3];
    }
    else{
      throw new HttpException("Invalid Channel");
    }
    $data = $_POST['data'];
    $event = new ServerSentEvent($channel,$data,$_POST['eventType']);
    return new JsonResponse(1);
  }

  public function getSubscribers(){
    $route = explode('.' ,\Drupal::routeMatch()->getRouteName());
    if($route[0] == 'server_sent_events' && $route[1] == 'channel' && $route[2] == 'subscribers'){
      $channel = $route[3];
    }
    else{
      throw new HttpException("Invalid Channel");
    }
    $channelEntity = EventsChannel::load($channel);
    $subcribers = $channelEntity->getSubscribers();
    $results = [];
    foreach($subcribers as $subcriberId){
      $subscription = ChannelSubscription::load($subcriberId);
      $results[] = [
        'id' => $subcriberId,
        'name' => $subscription->getOwner()->getDisplayName(),
        'uid' => $subscription->getOwnerId(),
      ];
    }
    return new JsonResponse($results);
  }
}
