<?php

namespace Drupal\server_sent_events\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\EntityPublishedInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface for defining Channel subscription entities.
 *
 * @ingroup server_sent_events
 */
interface ChannelSubscriptionInterface extends ContentEntityInterface, EntityPublishedInterface, EntityOwnerInterface {

  /**
   * Add get/set methods for your configuration properties here.
   */

  /**
   * Gets the Channel subscription name.
   *
   * @return string
   *   Name of the Channel subscription.
   */
  public function getName();

  /**
   * Sets the Channel subscription name.
   *
   * @param string $name
   *   The Channel subscription name.
   *
   * @return \Drupal\server_sent_events\Entity\ChannelSubscriptionInterface
   *   The called Channel subscription entity.
   */
  public function setName($name);

  /**
   * Gets the Channel subscription creation timestamp.
   *
   * @return int
   *   Creation timestamp of the Channel subscription.
   */
  public function getCreatedTime();

  /**
   * Sets the Channel subscription creation timestamp.
   *
   * @param int $timestamp
   *   The Channel subscription creation timestamp.
   *
   * @return \Drupal\server_sent_events\Entity\ChannelSubscriptionInterface
   *   The called Channel subscription entity.
   */
  public function setCreatedTime($timestamp);

}
