<?php

namespace Drupal\server_sent_events\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\EntityPublishedInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface for defining Server Sent Event Entity entities.
 *
 * @ingroup server_sent_events
 */
interface SSEventEntityInterface extends ContentEntityInterface, EntityPublishedInterface, EntityOwnerInterface {

  /**
   * Add get/set methods for your configuration properties here.
   */

  /**
   * Gets the Server Sent Event Entity name.
   *
   * @return string
   *   Name of the Server Sent Event Entity.
   */
  public function getName();

  /**
   * Sets the Server Sent Event Entity name.
   *
   * @param string $name
   *   The Server Sent Event Entity name.
   *
   * @return \Drupal\server_sent_events\Entity\SSEventEntityInterface
   *   The called Server Sent Event Entity entity.
   */
  public function setName($name);

  /**
   * Gets the Server Sent Event Entity creation timestamp.
   *
   * @return int
   *   Creation timestamp of the Server Sent Event Entity.
   */
  public function getCreatedTime();

  /**
   * Sets the Server Sent Event Entity creation timestamp.
   *
   * @param int $timestamp
   *   The Server Sent Event Entity creation timestamp.
   *
   * @return \Drupal\server_sent_events\Entity\SSEventEntityInterface
   *   The called Server Sent Event Entity entity.
   */
  public function setCreatedTime($timestamp);

}
