<?php

namespace Drupal\server_sent_events\Event;
use Drupal\server_sent_events\Entity\EventsChannel;
use Drupal\Component\EventDispatcher\Event;

/**
 * A server sent event that will be pushed.
 */
class ServerSentEvent extends Event {

  const SERVER_SENT_EVENT = 'server_sent_event_dispatch';

  public function __construct($channel, $event , $event_type = 'message') {
    $this->channel = EventsChannel::load($channel);
    $this->channel->pushEvent($event,$event_type);
    $this->type = $event_type;
    $this->data = $event;
    $this->dispatch();
  }

  public function dispatch(){
    \Drupal::service('event_dispatcher')->dispatch( $this,ServerSentEvent::SERVER_SENT_EVENT);
  }

}
