<?php

namespace Drupal\server_sent_events;

use Drupal\Core\Config\Entity\ConfigEntityListBuilder;
use Drupal\Core\Entity\EntityInterface;

/**
 * Provides a listing of Events channel entities.
 */
class EventsChannelListBuilder extends ConfigEntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['label'] = $this->t('Events channel');
    $header['id'] = $this->t('Machine name');
    $header['path'] = $this->t("Path");
    $header['status'] = $this->t('Status');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    $row['label'] = $entity->label();
    $row['id'] = $entity->id();
    $row['path'] = $entity->get('path');
    if($entity->get('status')){
      $row['status'] = $this->t('Active');
    }
    else{
      $row['status'] = $this->t('Disabled');
    }
    if($entity->get('locked')){
      $row['operations'] = $this->t('Locked');
    }
    else{
      $row += parent::buildRow($entity);
    }
    return $row ;
  }

}
