<?php

namespace Drupal\server_sent_events;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;
use Drupal\Core\Link;

/**
 * Defines a class to build a listing of Server Sent Event Entity entities.
 *
 * @ingroup server_sent_events
 */
class SSEventEntityListBuilder extends EntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['id'] = $this->t('Server Sent Event Entity ID');
    $header['name'] = $this->t('Name');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    /* @var \Drupal\server_sent_events\Entity\SSEventEntity $entity */
    $row['id'] = $entity->id();
    $row['name'] = Link::createFromRoute(
      $entity->label(),
      'entity.server_event_entity.edit_form',
      ['server_event_entity' => $entity->id()]
    );
    return $row + parent::buildRow($entity);
  }

}
